---
title: List Spectrum application protocols
---

[Skip to content](#_top)

[API Reference](https://developers.cloudflare.com/api/go)

[Spectrum](https://developers.cloudflare.com/api/go/resources/spectrum)

[Protocols](https://developers.cloudflare.com/api/go/resources/spectrum/subresources/protocols)

Copy Markdown

Open in **Claude**Open in **ChatGPT**Open in **Cursor**

---

**Copy Markdown****View as Markdown**

# List Spectrum application protocols

client.Spectrum.Protocols.List(ctx, query) (\*SinglePage\[[ProtocolListResponse](<https://developers.cloudflare.com/api/go/resources/spectrum#(resource)%20spectrum.protocols%20%3E%20(model)%20ProtocolListResponse%20%3E%20(schema)>)], error)

GET/zones/{zone\_id}/spectrum/protocols

Retrieves a list of Spectrum application protocols available for a zone.

##### Security

<details>

<summary>API Token</summary>



The preferred authorization scheme for interacting with the Cloudflare API. <a href="https://developers.cloudflare.com/fundamentals/api/get-started/create-token/">Create a token</a>.

**Example:**<code>Authorization: Bearer Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY</code>

</details>

<details>

<summary>API Email + API Key</summary>



The previous authorization scheme for interacting with the Cloudflare API, used in conjunction with a Global API key.

**Example:**<code>X-Auth-Email: user@example.com</code>

The previous authorization scheme for interacting with the Cloudflare API. When possible, use API tokens instead of Global API keys.

**Example:**<code>X-Auth-Key: 144c9defac04969c7bfad8efaa8ea194</code>

</details>

##### Accepted Permissions (at least one required)

`Zone Settings Write``Zone Settings Read`

##### ParametersExpand Collapse

<details>

<summary>

query ProtocolListParams

</summary>

ZoneID param.Field\[string]

Zone identifier.

maxLength32

<a href="#(resource)%20spectrum.protocols%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20zone_id">Link to this property</a>

</details>

[Link to this property](<#(resource)%20spectrum.protocols%20%3E%20(method)%20list%20%3E%20(params)%20default>)

##### ReturnsExpand Collapse

<details>

<summary>

type ProtocolListResponse struct{…}

</summary>

Description string

The full name of the application protocol.

<a href="#(resource)%20spectrum.protocols%20%3E%20(model)%20ProtocolListResponse%20%3E%20(schema)%20%3E%20(property)%20description">Link to this property</a>

Name string

The short name of the application protocol.

<a href="#(resource)%20spectrum.protocols%20%3E%20(model)%20ProtocolListResponse%20%3E%20(schema)%20%3E%20(property)%20name">Link to this property</a>

Ports \[]int64

The available listening ports for the given protocol.

<a href="#(resource)%20spectrum.protocols%20%3E%20(model)%20ProtocolListResponse%20%3E%20(schema)%20%3E%20(property)%20ports">Link to this property</a>

Transport string

The transport layer protocol used by the application protocol

<a href="#(resource)%20spectrum.protocols%20%3E%20(model)%20ProtocolListResponse%20%3E%20(schema)%20%3E%20(property)%20transport">Link to this property</a>

</details>

[Link to this property](<#(resource)%20spectrum.protocols%20%3E%20(model)%20ProtocolListResponse%20%3E%20(schema)>)

### List Spectrum application protocols

Go

HTTPTypeScriptPythonGoTerraform

```
package main

import (
  "context"
  "fmt"

  "github.com/cloudflare/cloudflare-go"
  "github.com/cloudflare/cloudflare-go/option"
  "github.com/cloudflare/cloudflare-go/spectrum"
)

func main() {
  client := cloudflare.NewClient(
    option.WithAPIToken("Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY"),
  )
  page, err := client.Spectrum.Protocols.List(context.TODO(), spectrum.ProtocolListParams{
    ZoneID: cloudflare.F("023e105f4ecef8ad9ca31a8372d0c353"),
  })
  if err != nil {
    panic(err.Error())
  }
  fmt.Printf("%+v\n", page)
}
```

200 example

```
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "success": true,
  "result": [
    {
      "description": "Minecraft Game Server",
      "name": "Minecraft",
      "ports": [
        25565
      ],
      "transport": "tcp"
    }
  ],
  "result_info": {
    "count": 1,
    "page": 1,
    "per_page": 20,
    "total_count": 2000,
    "total_pages": 100
  }
}
```

##### Returns Examples

200 example

```
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "success": true,
  "result": [
    {
      "description": "Minecraft Game Server",
      "name": "Minecraft",
      "ports": [
        25565
      ],
      "transport": "tcp"
    }
  ],
  "result_info": {
    "count": 1,
    "page": 1,
    "per_page": 20,
    "total_count": 2000,
    "total_pages": 100
  }
}
```